#pragma once

#include "domain/BaseStrategy.h"

#include "utils/Time.h"

class AidStrategy : public BaseStrategy {
private:
  Time& _timeModule = Time::getInstance();
  SemaphoreHandle_t _task1_mutex;
  SemaphoreHandle_t _task2_mutex;
  SemaphoreHandle_t _http_mutex;

  bool _isWritingToPrecedingBuffer = false;
  bool _recordingAudio = false;

  void _recordAudio(Audio* audioSource);
  void _writeToPrecedingBuffer(Audio* audioSource);
  bool _isNoiseDetected(Audio* audioSource);

  String _ready();
  void _sendAudio(Audio* audioSource);
  void _printContent(String payloadStart, String payloadEnd, Stream* stream);
  void _logContent(String payloadStart, String payloadEnd);

  String _formPayloadStart(unsigned long startMicros);
  String _formPayloadEnd();

  static void processTask(void* parameters);

public:
  AidStrategy(MicType micType, Http* http) : BaseStrategy(micType, http) {}
  ~AidStrategy() {}

  void setup();
  void process();
};