#pragma once

#include "infra/Audio.h"
#include "infra/Http.h"

class BaseStrategy {
protected:
  Audio* _audio;
  Audio* _audio1;
  Http* _http;

public:
  BaseStrategy(MicType micType, Http* http) {
    Serial.print("Free heap: ");
    Serial.println(esp_get_minimum_free_heap_size());

    _audio = new Audio(micType, I2S_NUM_0);

    Serial.print("Free heap: ");
    Serial.println(esp_get_minimum_free_heap_size());

    _audio1 = new Audio(micType, I2S_NUM_1);

    Serial.print("Free heap: ");
    Serial.println(esp_get_minimum_free_heap_size());

    _http = http;
  }

  ~BaseStrategy() {
    delete _audio;
    delete _audio1;
  }

  virtual void setup() = 0;
  virtual void process() = 0;
};