#ifndef _I2S_H
#define _I2S_H
#include <Arduino.h>
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"
#include "driver/i2s.h"
#include "esp_system.h"

enum MicType {
  ADMP441,
  ICS43434,
  M5GO,
  M5STACKFIRE
};

class I2S {
public:
  I2S(MicType micType, i2s_port_t i2sNum=I2S_NUM_0);
  int Read(char* data, int numData);
  int GetBitPerSample();

private:
  i2s_port_t _i2sNum;
  i2s_bits_per_sample_t BITS_PER_SAMPLE;
  void _setPins();
};

#endif // _I2S_H
